Index: /branches/version-2_11-dev/data/module/fpdf/fpdf.php
===================================================================
--- /branches/version-2_11-dev/data/module/fpdf/fpdf.php	(revision 20119)
+++ /branches/version-2_11-dev/data/module/fpdf/fpdf.php	(revision 20993)
@@ -3,68 +3,69 @@
 * FPDF                                                                         *
 *                                                                              *
-* Version: 1.6                                                                 *
-* Date:    2008-08-03                                                          *
+* Version: 1.7                                                                 *
+* Date:    2011-06-18                                                          *
 * Author:  Olivier PLATHEY                                                     *
 *******************************************************************************/
 
-define('FPDF_VERSION','1.6');
+define('FPDF_VERSION','1.7');
 
 class FPDF
 {
-var $page;               //current page number
-var $n;                  //current object number
-var $offsets;            //array of object offsets
-var $buffer;             //buffer holding in-memory PDF
-var $pages;              //array containing pages
-var $state;              //current document state
-var $compress;           //compression flag
-var $k;                  //scale factor (number of points in user unit)
-var $DefOrientation;     //default orientation
-var $CurOrientation;     //current orientation
-var $PageFormats;        //available page formats
-var $DefPageFormat;      //default page format
-var $CurPageFormat;      //current page format
-var $PageSizes;          //array storing non-default page sizes
-var $wPt,$hPt;           //dimensions of current page in points
-var $w,$h;               //dimensions of current page in user unit
-var $lMargin;            //left margin
-var $tMargin;            //top margin
-var $rMargin;            //right margin
-var $bMargin;            //page break margin
-var $cMargin;            //cell margin
-var $x,$y;               //current position in user unit
-var $lasth;              //height of last printed cell
-var $LineWidth;          //line width in user unit
-var $CoreFonts;          //array of standard font names
-var $fonts;              //array of used fonts
-var $FontFiles;          //array of font files
-var $diffs;              //array of encoding differences
-var $FontFamily;         //current font family
-var $FontStyle;          //current font style
-var $underline;          //underlining flag
-var $CurrentFont;        //current font info
-var $FontSizePt;         //current font size in points
-var $FontSize;           //current font size in user unit
-var $DrawColor;          //commands for drawing color
-var $FillColor;          //commands for filling color
-var $TextColor;          //commands for text color
-var $ColorFlag;          //indicates whether fill and text colors are different
-var $ws;                 //word spacing
-var $images;             //array of used images
-var $PageLinks;          //array of links in pages
-var $links;              //array of internal links
-var $AutoPageBreak;      //automatic page breaking
-var $PageBreakTrigger;   //threshold used to trigger page breaks
-var $InHeader;           //flag set when processing header
-var $InFooter;           //flag set when processing footer
-var $ZoomMode;           //zoom display mode
-var $LayoutMode;         //layout display mode
-var $title;              //title
-var $subject;            //subject
-var $author;             //author
-var $keywords;           //keywords
-var $creator;            //creator
-var $AliasNbPages;       //alias for total number of pages
-var $PDFVersion;         //PDF version number
+var $page;               // current page number
+var $n;                  // current object number
+var $offsets;            // array of object offsets
+var $buffer;             // buffer holding in-memory PDF
+var $pages;              // array containing pages
+var $state;              // current document state
+var $compress;           // compression flag
+var $k;                  // scale factor (number of points in user unit)
+var $DefOrientation;     // default orientation
+var $CurOrientation;     // current orientation
+var $StdPageSizes;       // standard page sizes
+var $DefPageSize;        // default page size
+var $CurPageSize;        // current page size
+var $PageSizes;          // used for pages with non default sizes or orientations
+var $wPt, $hPt;          // dimensions of current page in points
+var $w, $h;              // dimensions of current page in user unit
+var $lMargin;            // left margin
+var $tMargin;            // top margin
+var $rMargin;            // right margin
+var $bMargin;            // page break margin
+var $cMargin;            // cell margin
+var $x, $y;              // current position in user unit
+var $lasth;              // height of last printed cell
+var $LineWidth;          // line width in user unit
+var $fontpath;           // path containing fonts
+var $CoreFonts;          // array of core font names
+var $fonts;              // array of used fonts
+var $FontFiles;          // array of font files
+var $diffs;              // array of encoding differences
+var $FontFamily;         // current font family
+var $FontStyle;          // current font style
+var $underline;          // underlining flag
+var $CurrentFont;        // current font info
+var $FontSizePt;         // current font size in points
+var $FontSize;           // current font size in user unit
+var $DrawColor;          // commands for drawing color
+var $FillColor;          // commands for filling color
+var $TextColor;          // commands for text color
+var $ColorFlag;          // indicates whether fill and text colors are different
+var $ws;                 // word spacing
+var $images;             // array of used images
+var $PageLinks;          // array of links in pages
+var $links;              // array of internal links
+var $AutoPageBreak;      // automatic page breaking
+var $PageBreakTrigger;   // threshold used to trigger page breaks
+var $InHeader;           // flag set when processing header
+var $InFooter;           // flag set when processing footer
+var $ZoomMode;           // zoom display mode
+var $LayoutMode;         // layout display mode
+var $title;              // title
+var $subject;            // subject
+var $author;             // author
+var $keywords;           // keywords
+var $creator;            // creator
+var $AliasNbPages;       // alias for total number of pages
+var $PDFVersion;         // PDF version number
 
 /*******************************************************************************
@@ -73,138 +74,145 @@
 *                                                                              *
 *******************************************************************************/
-function FPDF($orientation='P', $unit='mm', $format='A4')
-{
-	//Some checks
+function FPDF($orientation='P', $unit='mm', $size='A4')
+{
+	// Some checks
 	$this->_dochecks();
-	//Initialization of properties
-	$this->page=0;
-	$this->n=2;
-	$this->buffer='';
-	$this->pages=array();
-	$this->PageSizes=array();
-	$this->state=0;
-	$this->fonts=array();
-	$this->FontFiles=array();
-	$this->diffs=array();
-	$this->images=array();
-	$this->links=array();
-	$this->InHeader=false;
-	$this->InFooter=false;
-	$this->lasth=0;
-	$this->FontFamily='';
-	$this->FontStyle='';
-	$this->FontSizePt=12;
-	$this->underline=false;
-	$this->DrawColor='0 G';
-	$this->FillColor='0 g';
-	$this->TextColor='0 g';
-	$this->ColorFlag=false;
-	$this->ws=0;
-	//Standard fonts
-	$this->CoreFonts=array('courier'=>'Courier', 'courierB'=>'Courier-Bold', 'courierI'=>'Courier-Oblique', 'courierBI'=>'Courier-BoldOblique',
-		'helvetica'=>'Helvetica', 'helveticaB'=>'Helvetica-Bold', 'helveticaI'=>'Helvetica-Oblique', 'helveticaBI'=>'Helvetica-BoldOblique',
-		'times'=>'Times-Roman', 'timesB'=>'Times-Bold', 'timesI'=>'Times-Italic', 'timesBI'=>'Times-BoldItalic',
-		'symbol'=>'Symbol', 'zapfdingbats'=>'ZapfDingbats');
-	//Scale factor
+	// Initialization of properties
+	$this->page = 0;
+	$this->n = 2;
+	$this->buffer = '';
+	$this->pages = array();
+	$this->PageSizes = array();
+	$this->state = 0;
+	$this->fonts = array();
+	$this->FontFiles = array();
+	$this->diffs = array();
+	$this->images = array();
+	$this->links = array();
+	$this->InHeader = false;
+	$this->InFooter = false;
+	$this->lasth = 0;
+	$this->FontFamily = '';
+	$this->FontStyle = '';
+	$this->FontSizePt = 12;
+	$this->underline = false;
+	$this->DrawColor = '0 G';
+	$this->FillColor = '0 g';
+	$this->TextColor = '0 g';
+	$this->ColorFlag = false;
+	$this->ws = 0;
+	// Font path
+	if(defined('FPDF_FONTPATH'))
+	{
+		$this->fontpath = FPDF_FONTPATH;
+		if(substr($this->fontpath,-1)!='/' && substr($this->fontpath,-1)!='\\')
+			$this->fontpath .= '/';
+	}
+	elseif(is_dir(dirname(__FILE__).'/font'))
+		$this->fontpath = dirname(__FILE__).'/font/';
+	else
+		$this->fontpath = '';
+	// Core fonts
+	$this->CoreFonts = array('courier', 'helvetica', 'times', 'symbol', 'zapfdingbats');
+	// Scale factor
 	if($unit=='pt')
-		$this->k=1;
+		$this->k = 1;
 	elseif($unit=='mm')
-		$this->k=72/25.4;
+		$this->k = 72/25.4;
 	elseif($unit=='cm')
-		$this->k=72/2.54;
+		$this->k = 72/2.54;
 	elseif($unit=='in')
-		$this->k=72;
+		$this->k = 72;
 	else
 		$this->Error('Incorrect unit: '.$unit);
-	//Page format
-	$this->PageFormats=array('a3'=>array(841.89,1190.55), 'a4'=>array(595.28,841.89), 'a5'=>array(420.94,595.28),
+	// Page sizes
+	$this->StdPageSizes = array('a3'=>array(841.89,1190.55), 'a4'=>array(595.28,841.89), 'a5'=>array(420.94,595.28),
 		'letter'=>array(612,792), 'legal'=>array(612,1008));
-	if(is_string($format))
-		$format=$this->_getpageformat($format);
-	$this->DefPageFormat=$format;
-	$this->CurPageFormat=$format;
-	//Page orientation
-	$orientation=strtolower($orientation);
+	$size = $this->_getpagesize($size);
+	$this->DefPageSize = $size;
+	$this->CurPageSize = $size;
+	// Page orientation
+	$orientation = strtolower($orientation);
 	if($orientation=='p' || $orientation=='portrait')
 	{
-		$this->DefOrientation='P';
-		$this->w=$this->DefPageFormat[0];
-		$this->h=$this->DefPageFormat[1];
+		$this->DefOrientation = 'P';
+		$this->w = $size[0];
+		$this->h = $size[1];
 	}
 	elseif($orientation=='l' || $orientation=='landscape')
 	{
-		$this->DefOrientation='L';
-		$this->w=$this->DefPageFormat[1];
-		$this->h=$this->DefPageFormat[0];
+		$this->DefOrientation = 'L';
+		$this->w = $size[1];
+		$this->h = $size[0];
 	}
 	else
 		$this->Error('Incorrect orientation: '.$orientation);
-	$this->CurOrientation=$this->DefOrientation;
-	$this->wPt=$this->w*$this->k;
-	$this->hPt=$this->h*$this->k;
-	//Page margins (1 cm)
-	$margin=28.35/$this->k;
+	$this->CurOrientation = $this->DefOrientation;
+	$this->wPt = $this->w*$this->k;
+	$this->hPt = $this->h*$this->k;
+	// Page margins (1 cm)
+	$margin = 28.35/$this->k;
 	$this->SetMargins($margin,$margin);
-	//Interior cell margin (1 mm)
-	$this->cMargin=$margin/10;
-	//Line width (0.2 mm)
-	$this->LineWidth=.567/$this->k;
-	//Automatic page break
+	// Interior cell margin (1 mm)
+	$this->cMargin = $margin/10;
+	// Line width (0.2 mm)
+	$this->LineWidth = .567/$this->k;
+	// Automatic page break
 	$this->SetAutoPageBreak(true,2*$margin);
-	//Full width display mode
-	$this->SetDisplayMode('fullwidth');
-	//Enable compression
+	// Default display mode
+	$this->SetDisplayMode('default');
+	// Enable compression
 	$this->SetCompression(true);
-	//Set default PDF version number
-	$this->PDFVersion='1.3';
+	// Set default PDF version number
+	$this->PDFVersion = '1.3';
 }
 
 function SetMargins($left, $top, $right=null)
 {
-	//Set left, top and right margins
-	$this->lMargin=$left;
-	$this->tMargin=$top;
+	// Set left, top and right margins
+	$this->lMargin = $left;
+	$this->tMargin = $top;
 	if($right===null)
-		$right=$left;
-	$this->rMargin=$right;
+		$right = $left;
+	$this->rMargin = $right;
 }
 
 function SetLeftMargin($margin)
 {
-	//Set left margin
-	$this->lMargin=$margin;
+	// Set left margin
+	$this->lMargin = $margin;
 	if($this->page>0 && $this->x<$margin)
-		$this->x=$margin;
+		$this->x = $margin;
 }
 
 function SetTopMargin($margin)
 {
-	//Set top margin
-	$this->tMargin=$margin;
+	// Set top margin
+	$this->tMargin = $margin;
 }
 
 function SetRightMargin($margin)
 {
-	//Set right margin
-	$this->rMargin=$margin;
+	// Set right margin
+	$this->rMargin = $margin;
 }
 
 function SetAutoPageBreak($auto, $margin=0)
 {
-	//Set auto page break mode and triggering margin
-	$this->AutoPageBreak=$auto;
-	$this->bMargin=$margin;
-	$this->PageBreakTrigger=$this->h-$margin;
-}
-
-function SetDisplayMode($zoom, $layout='continuous')
-{
-	//Set display mode in viewer
+	// Set auto page break mode and triggering margin
+	$this->AutoPageBreak = $auto;
+	$this->bMargin = $margin;
+	$this->PageBreakTrigger = $this->h-$margin;
+}
+
+function SetDisplayMode($zoom, $layout='default')
+{
+	// Set display mode in viewer
 	if($zoom=='fullpage' || $zoom=='fullwidth' || $zoom=='real' || $zoom=='default' || !is_string($zoom))
-		$this->ZoomMode=$zoom;
+		$this->ZoomMode = $zoom;
 	else
 		$this->Error('Incorrect zoom display mode: '.$zoom);
 	if($layout=='single' || $layout=='continuous' || $layout=='two' || $layout=='default')
-		$this->LayoutMode=$layout;
+		$this->LayoutMode = $layout;
 	else
 		$this->Error('Incorrect layout display mode: '.$layout);
@@ -213,60 +221,60 @@
 function SetCompression($compress)
 {
-	//Set page compression
+	// Set page compression
 	if(function_exists('gzcompress'))
-		$this->compress=$compress;
-	else
-		$this->compress=false;
+		$this->compress = $compress;
+	else
+		$this->compress = false;
 }
 
 function SetTitle($title, $isUTF8=false)
 {
-	//Title of document
+	// Title of document
 	if($isUTF8)
-		$title=$this->_UTF8toUTF16($title);
-	$this->title=$title;
+		$title = $this->_UTF8toUTF16($title);
+	$this->title = $title;
 }
 
 function SetSubject($subject, $isUTF8=false)
 {
-	//Subject of document
+	// Subject of document
 	if($isUTF8)
-		$subject=$this->_UTF8toUTF16($subject);
-	$this->subject=$subject;
+		$subject = $this->_UTF8toUTF16($subject);
+	$this->subject = $subject;
 }
 
 function SetAuthor($author, $isUTF8=false)
 {
-	//Author of document
+	// Author of document
 	if($isUTF8)
-		$author=$this->_UTF8toUTF16($author);
-	$this->author=$author;
+		$author = $this->_UTF8toUTF16($author);
+	$this->author = $author;
 }
 
 function SetKeywords($keywords, $isUTF8=false)
 {
-	//Keywords of document
+	// Keywords of document
 	if($isUTF8)
-		$keywords=$this->_UTF8toUTF16($keywords);
-	$this->keywords=$keywords;
+		$keywords = $this->_UTF8toUTF16($keywords);
+	$this->keywords = $keywords;
 }
 
 function SetCreator($creator, $isUTF8=false)
 {
-	//Creator of document
+	// Creator of document
 	if($isUTF8)
-		$creator=$this->_UTF8toUTF16($creator);
-	$this->creator=$creator;
+		$creator = $this->_UTF8toUTF16($creator);
+	$this->creator = $creator;
 }
 
 function AliasNbPages($alias='{nb}')
 {
-	//Define an alias for total number of pages
-	$this->AliasNbPages=$alias;
+	// Define an alias for total number of pages
+	$this->AliasNbPages = $alias;
 }
 
 function Error($msg)
 {
-	//Fatal error
+	// Fatal error
 	die('<b>FPDF error:</b> '.$msg);
 }
@@ -274,107 +282,107 @@
 function Open()
 {
-	//Begin document
-	$this->state=1;
+	// Begin document
+	$this->state = 1;
 }
 
 function Close()
 {
-	//Terminate document
+	// Terminate document
 	if($this->state==3)
 		return;
 	if($this->page==0)
 		$this->AddPage();
-	//Page footer
-	$this->InFooter=true;
+	// Page footer
+	$this->InFooter = true;
 	$this->Footer();
-	$this->InFooter=false;
-	//Close page
+	$this->InFooter = false;
+	// Close page
 	$this->_endpage();
-	//Close document
+	// Close document
 	$this->_enddoc();
 }
 
-function AddPage($orientation='', $format='')
-{
-	//Start a new page
+function AddPage($orientation='', $size='')
+{
+	// Start a new page
 	if($this->state==0)
 		$this->Open();
-	$family=$this->FontFamily;
-	$style=$this->FontStyle.($this->underline ? 'U' : '');
-	$size=$this->FontSizePt;
-	$lw=$this->LineWidth;
-	$dc=$this->DrawColor;
-	$fc=$this->FillColor;
-	$tc=$this->TextColor;
-	$cf=$this->ColorFlag;
+	$family = $this->FontFamily;
+	$style = $this->FontStyle.($this->underline ? 'U' : '');
+	$fontsize = $this->FontSizePt;
+	$lw = $this->LineWidth;
+	$dc = $this->DrawColor;
+	$fc = $this->FillColor;
+	$tc = $this->TextColor;
+	$cf = $this->ColorFlag;
 	if($this->page>0)
 	{
-		//Page footer
-		$this->InFooter=true;
+		// Page footer
+		$this->InFooter = true;
 		$this->Footer();
-		$this->InFooter=false;
-		//Close page
+		$this->InFooter = false;
+		// Close page
 		$this->_endpage();
 	}
-	//Start new page
-	$this->_beginpage($orientation,$format);
-	//Set line cap style to square
+	// Start new page
+	$this->_beginpage($orientation,$size);
+	// Set line cap style to square
 	$this->_out('2 J');
-	//Set line width
-	$this->LineWidth=$lw;
+	// Set line width
+	$this->LineWidth = $lw;
 	$this->_out(sprintf('%.2F w',$lw*$this->k));
-	//Set font
+	// Set font
 	if($family)
-		$this->SetFont($family,$style,$size);
-	//Set colors
-	$this->DrawColor=$dc;
+		$this->SetFont($family,$style,$fontsize);
+	// Set colors
+	$this->DrawColor = $dc;
 	if($dc!='0 G')
 		$this->_out($dc);
-	$this->FillColor=$fc;
+	$this->FillColor = $fc;
 	if($fc!='0 g')
 		$this->_out($fc);
-	$this->TextColor=$tc;
-	$this->ColorFlag=$cf;
-	//Page header
-	$this->InHeader=true;
+	$this->TextColor = $tc;
+	$this->ColorFlag = $cf;
+	// Page header
+	$this->InHeader = true;
 	$this->Header();
-	$this->InHeader=false;
-	//Restore line width
+	$this->InHeader = false;
+	// Restore line width
 	if($this->LineWidth!=$lw)
 	{
-		$this->LineWidth=$lw;
+		$this->LineWidth = $lw;
 		$this->_out(sprintf('%.2F w',$lw*$this->k));
 	}
-	//Restore font
+	// Restore font
 	if($family)
-		$this->SetFont($family,$style,$size);
-	//Restore colors
+		$this->SetFont($family,$style,$fontsize);
+	// Restore colors
 	if($this->DrawColor!=$dc)
 	{
-		$this->DrawColor=$dc;
+		$this->DrawColor = $dc;
 		$this->_out($dc);
 	}
 	if($this->FillColor!=$fc)
 	{
-		$this->FillColor=$fc;
+		$this->FillColor = $fc;
 		$this->_out($fc);
 	}
-	$this->TextColor=$tc;
-	$this->ColorFlag=$cf;
+	$this->TextColor = $tc;
+	$this->ColorFlag = $cf;
 }
 
 function Header()
 {
-	//To be implemented in your own inherited class
+	// To be implemented in your own inherited class
 }
 
 function Footer()
 {
-	//To be implemented in your own inherited class
+	// To be implemented in your own inherited class
 }
 
 function PageNo()
 {
-	//Get current page number
+	// Get current page number
 	return $this->page;
 }
@@ -382,9 +390,9 @@
 function SetDrawColor($r, $g=null, $b=null)
 {
-	//Set color for all stroking operations
+	// Set color for all stroking operations
 	if(($r==0 && $g==0 && $b==0) || $g===null)
-		$this->DrawColor=sprintf('%.3F G',$r/255);
-	else
-		$this->DrawColor=sprintf('%.3F %.3F %.3F RG',$r/255,$g/255,$b/255);
+		$this->DrawColor = sprintf('%.3F G',$r/255);
+	else
+		$this->DrawColor = sprintf('%.3F %.3F %.3F RG',$r/255,$g/255,$b/255);
 	if($this->page>0)
 		$this->_out($this->DrawColor);
@@ -393,10 +401,10 @@
 function SetFillColor($r, $g=null, $b=null)
 {
-	//Set color for all filling operations
+	// Set color for all filling operations
 	if(($r==0 && $g==0 && $b==0) || $g===null)
-		$this->FillColor=sprintf('%.3F g',$r/255);
-	else
-		$this->FillColor=sprintf('%.3F %.3F %.3F rg',$r/255,$g/255,$b/255);
-	$this->ColorFlag=($this->FillColor!=$this->TextColor);
+		$this->FillColor = sprintf('%.3F g',$r/255);
+	else
+		$this->FillColor = sprintf('%.3F %.3F %.3F rg',$r/255,$g/255,$b/255);
+	$this->ColorFlag = ($this->FillColor!=$this->TextColor);
 	if($this->page>0)
 		$this->_out($this->FillColor);
@@ -405,21 +413,21 @@
 function SetTextColor($r, $g=null, $b=null)
 {
-	//Set color for text
+	// Set color for text
 	if(($r==0 && $g==0 && $b==0) || $g===null)
-		$this->TextColor=sprintf('%.3F g',$r/255);
-	else
-		$this->TextColor=sprintf('%.3F %.3F %.3F rg',$r/255,$g/255,$b/255);
-	$this->ColorFlag=($this->FillColor!=$this->TextColor);
+		$this->TextColor = sprintf('%.3F g',$r/255);
+	else
+		$this->TextColor = sprintf('%.3F %.3F %.3F rg',$r/255,$g/255,$b/255);
+	$this->ColorFlag = ($this->FillColor!=$this->TextColor);
 }
 
 function GetStringWidth($s)
 {
-	//Get width of a string in the current font
-	$s=(string)$s;
-	$cw=&$this->CurrentFont['cw'];
-	$w=0;
-	$l=strlen($s);
+	// Get width of a string in the current font
+	$s = (string)$s;
+	$cw = &$this->CurrentFont['cw'];
+	$w = 0;
+	$l = strlen($s);
 	for($i=0;$i<$l;$i++)
-		$w+=$cw[$s[$i]];
+		$w += $cw[$s[$i]];
 	return $w*$this->FontSize/1000;
 }
@@ -427,6 +435,6 @@
 function SetLineWidth($width)
 {
-	//Set line width
-	$this->LineWidth=$width;
+	// Set line width
+	$this->LineWidth = $width;
 	if($this->page>0)
 		$this->_out(sprintf('%.2F w',$width*$this->k));
@@ -435,5 +443,5 @@
 function Line($x1, $y1, $x2, $y2)
 {
-	//Draw a line
+	// Draw a line
 	$this->_out(sprintf('%.2F %.2F m %.2F %.2F l S',$x1*$this->k,($this->h-$y1)*$this->k,$x2*$this->k,($this->h-$y2)*$this->k));
 }
@@ -441,11 +449,11 @@
 function Rect($x, $y, $w, $h, $style='')
 {
-	//Draw a rectangle
+	// Draw a rectangle
 	if($style=='F')
-		$op='f';
+		$op = 'f';
 	elseif($style=='FD' || $style=='DF')
-		$op='B';
-	else
-		$op='S';
+		$op = 'B';
+	else
+		$op = 'S';
 	$this->_out(sprintf('%.2F %.2F %.2F %.2F re %s',$x*$this->k,($this->h-$y)*$this->k,$w*$this->k,-$h*$this->k,$op));
 }
@@ -453,108 +461,84 @@
 function AddFont($family, $style='', $file='')
 {
-	//Add a TrueType or Type1 font
-	$family=strtolower($family);
+	// Add a TrueType, OpenType or Type1 font
+	$family = strtolower($family);
 	if($file=='')
-		$file=str_replace(' ','',$family).strtolower($style).'.php';
-	if($family=='arial')
-		$family='helvetica';
-	$style=strtoupper($style);
+		$file = str_replace(' ','',$family).strtolower($style).'.php';
+	$style = strtoupper($style);
 	if($style=='IB')
-		$style='BI';
-	$fontkey=$family.$style;
+		$style = 'BI';
+	$fontkey = $family.$style;
 	if(isset($this->fonts[$fontkey]))
 		return;
-	include($this->_getfontpath().$file);
-	if(!isset($name))
-		$this->Error('Could not include font definition file');
-	$i=count($this->fonts)+1;
-	$this->fonts[$fontkey]=array('i'=>$i, 'type'=>$type, 'name'=>$name, 'desc'=>$desc, 'up'=>$up, 'ut'=>$ut, 'cw'=>$cw, 'enc'=>$enc, 'file'=>$file);
-	if($diff)
-	{
-		//Search existing encodings
-		$d=0;
-		$nb=count($this->diffs);
-		for($i=1;$i<=$nb;$i++)
-		{
-			if($this->diffs[$i]==$diff)
-			{
-				$d=$i;
-				break;
-			}
-		}
-		if($d==0)
-		{
-			$d=$nb+1;
-			$this->diffs[$d]=$diff;
-		}
-		$this->fonts[$fontkey]['diff']=$d;
-	}
-	if($file)
-	{
-		if($type=='TrueType')
-			$this->FontFiles[$file]=array('length1'=>$originalsize);
+	$info = $this->_loadfont($file);
+	$info['i'] = count($this->fonts)+1;
+	if(!empty($info['diff']))
+	{
+		// Search existing encodings
+		$n = array_search($info['diff'],$this->diffs);
+		if(!$n)
+		{
+			$n = count($this->diffs)+1;
+			$this->diffs[$n] = $info['diff'];
+		}
+		$info['diffn'] = $n;
+	}
+	if(!empty($info['file']))
+	{
+		// Embedded font
+		if($info['type']=='TrueType')
+			$this->FontFiles[$info['file']] = array('length1'=>$info['originalsize']);
 		else
-			$this->FontFiles[$file]=array('length1'=>$size1, 'length2'=>$size2);
-	}
+			$this->FontFiles[$info['file']] = array('length1'=>$info['size1'], 'length2'=>$info['size2']);
+	}
+	$this->fonts[$fontkey] = $info;
 }
 
 function SetFont($family, $style='', $size=0)
 {
-	//Select a font; size given in points
-	global $fpdf_charwidths;
-
-	$family=strtolower($family);
+	// Select a font; size given in points
 	if($family=='')
-		$family=$this->FontFamily;
-	if($family=='arial')
-		$family='helvetica';
-	elseif($family=='symbol' || $family=='zapfdingbats')
-		$style='';
-	$style=strtoupper($style);
+		$family = $this->FontFamily;
+	else
+		$family = strtolower($family);
+	$style = strtoupper($style);
 	if(strpos($style,'U')!==false)
 	{
-		$this->underline=true;
-		$style=str_replace('U','',$style);
-	}
-	else
-		$this->underline=false;
+		$this->underline = true;
+		$style = str_replace('U','',$style);
+	}
+	else
+		$this->underline = false;
 	if($style=='IB')
-		$style='BI';
+		$style = 'BI';
 	if($size==0)
-		$size=$this->FontSizePt;
-	//Test if font is already selected
+		$size = $this->FontSizePt;
+	// Test if font is already selected
 	if($this->FontFamily==$family && $this->FontStyle==$style && $this->FontSizePt==$size)
 		return;
-	//Test if used for the first time
-	$fontkey=$family.$style;
+	// Test if font is already loaded
+	$fontkey = $family.$style;
 	if(!isset($this->fonts[$fontkey]))
 	{
-		//Check if one of the standard fonts
-		if(isset($this->CoreFonts[$fontkey]))
-		{
-			if(!isset($fpdf_charwidths[$fontkey]))
-			{
-				//Load metric file
-				$file=$family;
-				if($family=='times' || $family=='helvetica')
-					$file.=strtolower($style);
-				include($this->_getfontpath().$file.'.php');
-				if(!isset($fpdf_charwidths[$fontkey]))
-					$this->Error('Could not include font metric file');
-			}
-			$i=count($this->fonts)+1;
-			$name=$this->CoreFonts[$fontkey];
-			$cw=$fpdf_charwidths[$fontkey];
-			$this->fonts[$fontkey]=array('i'=>$i, 'type'=>'core', 'name'=>$name, 'up'=>-100, 'ut'=>50, 'cw'=>$cw);
+		// Test if one of the core fonts
+		if($family=='arial')
+			$family = 'helvetica';
+		if(in_array($family,$this->CoreFonts))
+		{
+			if($family=='symbol' || $family=='zapfdingbats')
+				$style = '';
+			$fontkey = $family.$style;
+			if(!isset($this->fonts[$fontkey]))
+				$this->AddFont($family,$style);
 		}
 		else
 			$this->Error('Undefined font: '.$family.' '.$style);
 	}
-	//Select it
-	$this->FontFamily=$family;
-	$this->FontStyle=$style;
-	$this->FontSizePt=$size;
-	$this->FontSize=$size/$this->k;
-	$this->CurrentFont=&$this->fonts[$fontkey];
+	// Select it
+	$this->FontFamily = $family;
+	$this->FontStyle = $style;
+	$this->FontSizePt = $size;
+	$this->FontSize = $size/$this->k;
+	$this->CurrentFont = &$this->fonts[$fontkey];
 	if($this->page>0)
 		$this->_out(sprintf('BT /F%d %.2F Tf ET',$this->CurrentFont['i'],$this->FontSizePt));
@@ -563,9 +547,9 @@
 function SetFontSize($size)
 {
-	//Set font size in points
+	// Set font size in points
 	if($this->FontSizePt==$size)
 		return;
-	$this->FontSizePt=$size;
-	$this->FontSize=$size/$this->k;
+	$this->FontSizePt = $size;
+	$this->FontSize = $size/$this->k;
 	if($this->page>0)
 		$this->_out(sprintf('BT /F%d %.2F Tf ET',$this->CurrentFont['i'],$this->FontSizePt));
@@ -574,7 +558,7 @@
 function AddLink()
 {
-	//Create a new internal link
-	$n=count($this->links)+1;
-	$this->links[$n]=array(0, 0);
+	// Create a new internal link
+	$n = count($this->links)+1;
+	$this->links[$n] = array(0, 0);
 	return $n;
 }
@@ -582,26 +566,26 @@
 function SetLink($link, $y=0, $page=-1)
 {
-	//Set destination of internal link
+	// Set destination of internal link
 	if($y==-1)
-		$y=$this->y;
+		$y = $this->y;
 	if($page==-1)
-		$page=$this->page;
-	$this->links[$link]=array($page, $y);
+		$page = $this->page;
+	$this->links[$link] = array($page, $y);
 }
 
 function Link($x, $y, $w, $h, $link)
 {
-	//Put a link on the page
-	$this->PageLinks[$this->page][]=array($x*$this->k, $this->hPt-$y*$this->k, $w*$this->k, $h*$this->k, $link);
+	// Put a link on the page
+	$this->PageLinks[$this->page][] = array($x*$this->k, $this->hPt-$y*$this->k, $w*$this->k, $h*$this->k, $link);
 }
 
 function Text($x, $y, $txt)
 {
-	//Output a string
-	$s=sprintf('BT %.2F %.2F Td (%s) Tj ET',$x*$this->k,($this->h-$y)*$this->k,$this->_escape($txt));
+	// Output a string
+	$s = sprintf('BT %.2F %.2F Td (%s) Tj ET',$x*$this->k,($this->h-$y)*$this->k,$this->_escape($txt));
 	if($this->underline && $txt!='')
-		$s.=' '.$this->_dounderline($x,$y,$txt);
+		$s .= ' '.$this->_dounderline($x,$y,$txt);
 	if($this->ColorFlag)
-		$s='q '.$this->TextColor.' '.$s.' Q';
+		$s = 'q '.$this->TextColor.' '.$s.' Q';
 	$this->_out($s);
 }
@@ -609,5 +593,5 @@
 function AcceptPageBreak()
 {
-	//Accept automatic page break or not
+	// Accept automatic page break or not
 	return $this->AutoPageBreak;
 }
